# QueryMsg

The only difference when handling query messages in the fixed multisig ADO is the use of the.        `#[andr_query]`attribute. Just like `#[andr_instantiate]` and `#[andr_exec]`, this macro ensures that the [common ADO queries](/andromeda/platform-and-framework/ado-base/andromedaquery.md)  are included.

{% code title="msg.rs" %}

```rust
#[andr_query]
#[cw_serde]
#[derive(QueryResponses)]
pub enum QueryMsg {
    ...
}
```

{% endcode %}

This case is handled here:

{% code title="contract.rs" %}

```rust
#[cfg_attr(not(feature = "library"), entry_point)]
pub fn query(deps: Deps, env: Env, msg: QueryMsg) -> Result<Binary, ContractError> {
    match msg {
    
        /// handle base queries
        _ => ADOContract::default().query(deps, env, msg),
    }
}
```

{% endcode %}

The remaining logic for the queries is the same as in both the CW3 and ADO versions.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.andromedaprotocol.io/andromeda/developing-an-ado/cw3-example/querymsg.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
